/*
 * defines.h
 * Thomas Nemeth, le 09.09.2000
 *
 *   Copyright (C) 1999  Thomas Nemeth
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _DEFINES_H_
#define _DEFINES_H_

#include "config.h"

/* ====== CONSTANTES ET DFINITIONS GLOBALES ============================== */

/* COMPILATION */
#define VERSION            "0.5"

/* VALEURS PAR DFAUT */
#define DEFAULT_DIRECTORY  ".notify"
#define REMINDER_DIRECTORY "messages"
#define MESSAGE_FILE       "message"
#define CONFIG_FILE        "config"
#define MESSAGES_LIST      "msglist"
#define MP3_PLAYER         "mpg123"
#define WAV_PLAYER         "play"
#define ALARM_SOUNDFILE    "alarm.wav"
#define NOTIFY_SOUNDFILE   "notify.wav"
#define NB_SOUND_PLAY      3
#define MAXSTRLEN          1024
#define DEFAULT_TMPFILE    ".tmpfile"

/* MACROS STANDARD PERSO */
#define MY_ALLOC(var, nb, type) \
do {\
    if((var = (type *)malloc((nb)*sizeof(type))) == NULL) {\
        int CARAC;\
        printf("Allocation error for "#var" !!!\n");\
        printf("=>\n");\
        CARAC = getchar();\
    }\
} \
while (0)

#define MY_STOP {int CARAC;printf("=>\n");CARAC = getchar();}


/* ====== STRUCTURES DE DONNES =========================================== */

typedef struct _t_filelist {
    char                *filename;
    char                *name;
    struct _t_filelist  *next;
} FileList;

typedef struct _t_config {
    char     *mp3_player;
    char     *wav_player;
    char     *alarm_sound;
    char     *notify_sound;
    char     *list_file;
    FileList *list;
    int       nb_sound_play;
    char     *filename;
    char     *soundfile;
    char     *option;
    int       mode;
    int       command;
} Config;

Config config;


/* ====== CONSTANTES RELATIVES  LA CONFIGURATION ========================= */

#define VRAI 1
#define FAUX 0

#define SIMPLE 1
#define DOUBLE 2

#define CFG_UNKNWN  0
#define CFG_MP3PLY  1
#define CFG_WAVPLY  2
#define CFG_ALARMF  3
#define CFG_NOTIFF  4
#define CFG_LSTFIL  5
#define CFG_NSOUND  6

#define KEY_MP3 "mp3player"
#define KEY_WAV "wavplayer"
#define KEY_ALR "alarmsound"
#define KEY_NOT "notifysound"
#define KEY_MSG "messageslist"
#define KEY_NBS "nbsoundplay"


/* ====== CONSTANTES RELATIVES AUX MODES DE FONCTIONNEMENT ================ */

/* MODES */
#define NOTH 0
#define COMD 1
#define MNGT 2
#define AUTO 3
#define TEMP 4

/* COMMANDES */
#define NON   0
#define OP1   1
#define OP2   2
#define OP3   3
#define OP4   4
#define ADD 100
#define LST 200
#define DEL 300
#define FIL 400
#define MSG 500


#endif
